{ gpr_pas_example_1a.pas }
PROGRAM gpr_pas_example_1a;

%include '/sys/ins/base.ins.pas';
%include '/sys/ins/gpr.ins.pas';
%include '/usr/include/tml/tml.ins.pas';

PROCEDURE create_bitmap(OUT return_bitmap : integer32); EXTERN;
PROCEDURE enable_all_keys; EXTERN;
PROCEDURE tml_dp_damage_repair(viewport_handle : tml_c_bitmap_id); EXTERN;

VAR
    zero              :integer32     :=  0;
    filename          :array[0..8] of char;
    filename_length   :integer32;
    display_model     :tml_c_model;
    display_viewport  :tml_c_view_port;
    display_format    :tml_c_format;
    start_display     :c_model_pos;
    dummy_integer     :integer32;
    dummy_format      :tml_c_format;
    n                 :array[0..5] of char;
    bitmap            :integer32;
    unob              :boolean;
    ev_type           :gpr_$event_t;
    ev_value          :char;
    ret_coord         :gpr_$position_t;
    status            :status_$t;

BEGIN              { main }

    { initialize TMLib }
    tml_init;

    { associate all viewport objects with the GPR graphic system }
    tml_c_tml_dp_set_dflt_vpftbl(tml_c_tml_dp_get_gpr_vpftbl());

    { create a model from the ASCII file test_file }
    filename := 'test_file';
    filename_length := SIZEOF(filename);
    display_model := tml_c_read_uasc_path(filename[0], filename_length);

    { if a model is created successfully, continue }
    IF (display_model <> NIL) THEN
       BEGIN
       { allocate a viewport }
       display_viewport := view_port_class_alloc;

       { create a graphics display area
        use a routine that depends on the graphics system }
        create_bitmap(bitmap);

       { assign the display area to the viewport }
       dummy_integer :=
         view_port_set_handle(display_viewport,
                              tml_c_bitmap_id(addr(bitmap)));

       { create a format and attach it to the viewport }
       dummy_format := NIL;
       dummy_integer:=
         view_port_attach_format(display_viewport,
                                 dummy_format, zero, zero);

       { get a handle to the format created by the last call }
       display_format := view_port_get_format(display_viewport);

       { attach the model to the format that is associated with
        the viewport }
       format_attach(display_format, display_model);

       { display the first viewport }
       tml_dp_damage_repair(view_port_get_handle(display_viewport));

       { enable keyboard }
       enable_all_keys();

       { wait for input, then exit }
       unob := gpr_$event_wait(ev_type, ev_value, ret_coord, status);

       { cleanup }
       view_port_free( display_viewport);
       format_free( display_format);
       model_free( display_model);
       END;
END.

