/**************************************************************************************
    csm_c_interface_pvt.cxx
    definitions for functions declared in csm_c_types.h for the C language
      interface of the Character Set Manager.
    NOTE: These functions are included here, not in csm_c_interface.cxx,
       because they are used by the CSM itself.

    (c) Copyright Apollo Computer Inc., 1987 (unpublished)
     --------------------------------------------------------------------
    |THE FOLLOWING PROGRAMS ARE THE SOLE PROPERTY OF APOLLO COMPUTER INC.|
    |      AND CONTAIN ITS PROPRIETARY AND CONFIDENTIAL INFORMATION.     |
     --------------------------------------------------------------------
**************************************************************************************/

#include <stdio.h>
#include <tml/char_set_mgr.hxx>
#include <tml/tml_os_depends.hxx>

typedef void* csm_c_char_set;

char* tml_c_tml_os_byte_copy(char* from, char* to, long count)
{
    return(tml_os_byte_copy(from, to, count));
}

char* tml_c_tml_os_alloc(unsigned long nelem, unsigned long elsize)
{
    return(tml_os_alloc(nelem, elsize));
}

void tml_c_tml_os_free(char* ptr)
{
    tml_os_free(ptr);
}

long char_set_get_dir_to_char(csm_c_char_set cs_p, unsigned char* c)
{
    return ((char_set*) cs_p)->get_dir_to_char(c);
}


