/**************************************************************************************
    File csm_extend.cxx
    Declarations of persistent types used by the CSM

    (c) Copyright Apollo Computer Inc., 1990 (unpublished)
     --------------------------------------------------------------------
    |THE FOLLOWING PROGRAMS ARE THE SOLE PROPERTY OF APOLLO COMPUTER INC.|
    |      AND CONTAIN ITS PROPRIETARY AND CONFIDENTIAL INFORMATION.     |
     --------------------------------------------------------------------
**************************************************************************************/

/**********************************************************************************
    SEE EXPLANATORY NOTE AT HEAD OF FILE EXTEND.CXX
**********************************************************************************/

#include <stdio.h>
#include <tml/char_set_mgr.hxx>

/**********************************************************************************
    sample objects for preloaded types
**********************************************************************************/

#ifndef apollo_global
syll_frag_char_set  tml_sample_syll_frag_char_set;
alpha_char_set      tml_sample_alpha_char_set;
char_set            tml_sample_char_set;
#endif

/**********************************************************************************
    preloaded character set types and instances
**********************************************************************************/

#ifdef apollo_global
tml_ext_type tml_syll_frag_char_set_ext_t;
tml_ext_type tml_alpha_char_set_ext_t;
tml_ext_type tml_char_set_ext_t;

tml_type     tml_syll_frag_char_set_t;
tml_type     tml_alpha_char_set_t;
tml_type     tml_char_set_t;

tml_type* const tml_syll_frag_char_set;
tml_type* const tml_alpha_char_set;
tml_type* const tml_char_set;

#else
tml_ext_type tml_syll_frag_char_set_ext_t
    = { 0x41192edb,
        0x4000,
        0x0000,
        0x0d,
        {0x00, 0x01, 0x9f, 0xab, 0x00, 0x00, 0x00} };

tml_ext_type tml_alpha_char_set_ext_t
    = { 0x41192e22,
        0x0000,
        0x0000,
        0x0d,
        {0x00, 0x01, 0x9f, 0xab, 0x00, 0x00, 0x00} };

tml_ext_type tml_char_set_ext_t
    = { 0x41192d9d,
        0xc000,
        0x0000,
        0x0d,
        {0x00, 0x01, 0x9f, 0xab, 0x00, 0x00, 0x00} };

tml_type tml_syll_frag_char_set_t = {&tml_syll_frag_char_set_ext_t, &tml_sample_syll_frag_char_set, 0};
tml_type tml_alpha_char_set_t     = {&tml_alpha_char_set_ext_t, &tml_sample_alpha_char_set, &tml_syll_frag_char_set_t};
tml_type tml_char_set_t           = {&tml_char_set_ext_t, &tml_sample_char_set, &tml_alpha_char_set_t};

tml_type* const tml_syll_frag_char_set  = &tml_syll_frag_char_set_t;
tml_type* const tml_alpha_char_set      = &tml_alpha_char_set_t;
tml_type* const tml_char_set            = &tml_char_set_t;

#endif

/* Include extend.cxx here if not TMLib build, when this file is included */
/*   in tml_extend.cxx which in turn includes extend.cxx */

#ifndef tml_extend_cxx
#include <tml/extend.cxx>
#endif
