/**************************************************************************************
    tml_dp_x_graph.h
    Header file for C++ and C users of tml_dp_x_graph.c

    (c) Copyright Apollo Computer Inc., 1987 (unpublished)
     --------------------------------------------------------------------
    |THE FOLLOWING PROGRAMS ARE THE SOLE PROPERTY OF APOLLO COMPUTER INC.|
    |      AND CONTAIN ITS PROPRIETARY AND CONFIDENTIAL INFORMATION.     |
     --------------------------------------------------------------------
**************************************************************************************/

/* Declares font service functions unique to X Windows */
/* Defines structure for contents of bitmap_id pointer to be passed to */
/*     tml_dp_make_graphic_handle(), and passed as argument to other */
/*     rendering routines in tml_dp_x_graph.c. */
/* To use, ALLOCATE this structure FROM FREE STORE and initialize with: */
/*     pointer to Display obtained from XOpenDisplay() */
/*     Window id obtained from XCreateWindow() or XCreateSimpleWindow() */
/*     GC (graphics context) id obtained from XCreateGC() */
/* HINTS: (1) Make window size of viewport */
/*        (2) Window event mask will include all expose events, */
/*            and visibility change events. If you do not set these */
/*            masks, tml++ will do it for you. The DontPropogate mask */
/*            will remain as you set it. */
/*        (3) Create gc appropriately for the graphics/text operations */
/*            you have in mind on the hardware you are using */

#ifndef tml_dp_x_graph_h
#define tml_dp_x_graph_h

#include <tml/tml_prototype_status.h>

#ifdef not_vanilla_C

extern void tml_dp_set_font_display(Display *display);
extern void tml_dp_add_clip_rect(void* bitmap_id, long ulx, long uly, long width, long height);
extern void tml_dp_record_new_size(void* bitmap_id, long width, long height);
extern long tml_dp_get_creation_x_size(void* bitmap_id);
extern long tml_dp_get_creation_y_size(void* bitmap_id);

#else

extern      tml_dp_set_font_display();
extern      tml_dp_add_clip_rect();
extern      tml_dp_record_new_size();
extern long tml_dp_get_creation_x_size();
extern long tml_dp_get_creation_y_size();

#endif

struct window_info {
    Display    *display;
    Window      window;
    GC          gc;
    long        depth;
    long        creation_x_size;
    long        creation_y_size;
    };

#endif 
/* tml_dp_x_graph_h */
