(**************************************************************************************
    tml_structs.ins.pas
    Declarations of proxies for C++ classes used in
        C interface functions

    (c) Copyright Apollo Computer Inc., 1990 (unpublished)
     --------------------------------------------------------------------
    |THE FOLLOWING PROGRAMS ARE THE SOLE PROPERTY OF APOLLO COMPUTER INC.|
    |      AND CONTAIN ITS PROPRIETARY AND CONFIDENTIAL INFORMATION.     |
     --------------------------------------------------------------------
**************************************************************************************)

(******************************************************************************
    Structures shared by C++ and C callers of C interface functions

******************************************************************************)

(* STRUCTURE USED TO CAPTURE CONTENTS OF A MEMBER OF CLASS MODEL_POS *)

TYPE tml_c_model_pos = RECORD
        in_node: UNIV_PTR;
        char_index: INTEGER32;
    END;
TYPE C_MODEL_POS               = tml_c_model_pos;



(* STRUCTURE USED TO CAPTURE CONTENTS OF A MEMBER OF CLASS SCREEN_XY *)
TYPE tml_c_screen_xy = RECORD
        at_x: INTEGER32;
        at_y: INTEGER32;
    END;
TYPE C_SCREEN_XY               = tml_c_screen_xy;



(* STRUCTURE USED TO CAPTURE CONTENTS OF A MEMBER OF CLASS MODEL_RANGE *)
TYPE tml_c_model_range = RECORD
        start: C_MODEL_POS;
        finish: C_MODEL_POS;
    END;
TYPE C_MODEL_RANGE             = tml_c_model_range;



(* STRUCTURE USED TO CAPTURE CONTENTS OF A MEMBER OF CLASS MARK_LIST *)
TYPE tml_c_mark_list = RECORD
        next: ^tml_c_mark_list;
        prior: ^tml_c_mark_list;
        mark_range: ^C_MODEL_RANGE;
    END;
TYPE C_MARK_LIST               = tml_c_mark_list;



(* STRUCTURE USED TO CAPTURE CONTENTS OF A MEMBER OF CLASS XY_COORD *)
TYPE tml_c_xy_coord = RECORD
        x_coord: INTEGER32;
        y_coord: INTEGER32;
    END;
TYPE C_XY_COORD                = tml_c_xy_coord;



(* TYPEDEF FOR A POINTER TO THE FUNCTION WHICH DRAWS THE CURSOR *)

    TYPE tml_c_cursor_draw = ^FUNCTION(
          in_bitmap : UNIV_PTR;
          wherex : INTEGER32;
          wherey : INTEGER32;
          cursor_hi : INTEGER32;
          cursor_wide : INTEGER32;
          erase : INTEGER32)  : INTEGER32;
TYPE C_CURSOR_DRAW             = tml_c_cursor_draw;



(* TYPEDEF FOR A POINTER TO THE FUNCTION WHICH THE MARK-DRAWING FUNCTION USES TO ACTUALLY DRAW A MARK *)

    TYPE tml_c_core_m_draw = ^PROCEDURE(
          bitmap_handle : UNIV_PTR;
          src_ulx : INTEGER32;
          src_uly : INTEGER32;
          src_lrx : INTEGER32;
          src_lry : INTEGER32;
          dst_ulx : INTEGER32;
          dst_uly : INTEGER32;
          rop : INTEGER32) ;
TYPE C_CORE_M_DRAW             = tml_c_core_m_draw;



(* TYPEDEF FOR A POINTER TO THE FUNCTION WHICH DRAWS A MARK *)

    TYPE tml_c_draw_m_draw = ^FUNCTION(
          in_viewport : UNIV_PTR;
          core_func : C_CORE_M_DRAW;
          start_draw : C_MODEL_POS;
          end_draw : C_MODEL_POS;
          erase : INTEGER32)  : INTEGER32;
TYPE C_DRAW_M_DRAW             = tml_c_draw_m_draw;



(* TYPEDEF FOR A POINTER TO A PROPERTY FUNCTION *)

    TYPE tml_c_prop_func_pt = ^FUNCTION(
          arg_vec : UNIV_PTR)  : UNIV_PTR;
TYPE C_PROP_FUNC_PT            = tml_c_prop_func_pt;



(* TYPEDEF FOR A POINTER TO A SEARCH FUNCTION *)

    TYPE tml_c_search_func = ^FUNCTION(
          search_area : C_MODEL_RANGE;
      VAR found_str : C_MODEL_RANGE;
          pattern : UNIV_PTR;
          fwd : INTEGER32)  : INTEGER32;
TYPE C_SEARCH_FUNC             = tml_c_search_func;



(* TYPEDEF FOR A POINTER TO A REGULAR EXPRESSION COMPILER FUNCTION *)

    TYPE tml_c_compile_func = ^FUNCTION(
      VAR exp_start : CHAR;
          len : INTEGER32;
          pattern : UNIV_PTR;
          pattern_max : INTEGER32;
          case_sens : INTEGER32)  : INTEGER32;
TYPE C_COMPILE_FUNC            = tml_c_compile_func;



(* TYPEDEF FOR A POINTER TO A SEARCH NAVIGATION FUNCTION *)

    TYPE tml_c_search_nav_func = ^FUNCTION(
      VAR ptr : C_MODEL_POS)  : PTR_TO_CHAR;
TYPE C_SEARCH_NAV_FUNC         = tml_c_search_nav_func;



(* STRUCTURE USED TO CAPTURE CONTENTS OF A MEMBER OF CLASS SEARCH_ENV *)
TYPE tml_c_search_env = RECORD
        next: ^tml_c_search_env;
        search_rtn: C_SEARCH_FUNC;
        compile_rtn: C_COMPILE_FUNC;
        next_char_func: C_SEARCH_NAV_FUNC;
        prior_char_func: C_SEARCH_NAV_FUNC;
        this_char_func: C_SEARCH_NAV_FUNC;
    END;
TYPE C_SEARCH_ENV              = tml_c_search_env;



(* STRUCTURE USED TO SPECIFY PRINTING PARAMETERS *)
TYPE print_db = RECORD
        pointsize: INTEGER32;
        columns: INTEGER32;
        orientation: INTEGER32;
    END;


(* C VERSION OF THAT STRUCTURE *)
TYPE tml_c_print_db = RECORD
        pointsize: INTEGER32;
        columns: INTEGER32;
        page_orientation: INTEGER32;
    END;
TYPE C_PRINT_DB                = tml_c_print_db;


